The BOOST_PP_SEQ_FOLD_RIGHT_s macro folds (or accumulates) the elements of a seq right-to-left. It reenters BOOST_PP_SEQ_FOLD_RIGHT with maximum efficiency.

#### Usage

BOOST_PP_SEQ_FOLD_RIGHT_ ## s(op, state, seq)

#### Arguments

s
  The next available BOOST_PP_SEQ_FOLD_LEFT fold step.
op
  A ternary operation of the form op(s, state, elem). This macro is called for each element in seq--each time returning a new state. This operation is expanded by BOOST_PP_SEQ_FOLD_RIGHT with the next available fold step, the current state, and the current element.
state
  The initial state of the fold.
seq
  The seq to be folded.

#### Remarks

For the seq, (0)(1)(2), this macro expands to:
op(s, op(s, op(s, state, 2), 1), 0)

#### See Also

- BOOST_PP_SEQ_FOLD_RIGHT

#### Requirements

Header: <boost/preprocessor/seq/fold_right.hpp>

#### Sample Code

    #include <boost/preprocessor/cat.hpp>
    #include <boost/preprocessor/seq/fold_left.hpp>
    #include <boost/preprocessor/seq/fold_right.hpp>
    #include <boost/preprocessor/seq/seq.hpp>

    #define S1 (a)(b)(c)
    #define S2 (S1)(S1)(S1)

    #define OP(s, state, x) state (BOOST_PP_SEQ_FOLD_RIGHT_ ## s(OP_2, _, x))
    #define OP_2(s, state, x) BOOST_PP_CAT(state, x)

    BOOST_PP_SEQ_FOLD_LEFT(OP, BOOST_PP_SEQ_NIL, S2)
    // expands to (_cba)(_cba)(_cba)